/**
 * Main script for the BonusThemes.com adHome Template
 *
 * @package bt_adhome
 * @version 1.0
 * @copyright BonusThemes.com 2008
 * @link http://www.bonusthemes.com/goto/bt_adhome
 */


function addEvent(obj, event, func)
{
	if (obj.addEventListener)
		obj.addEventListener(event, func, false);
	else if (obj.attachEvent)
		obj.attachEvent('on' + event, func);
}

function adhome_ch_create(mi)
{
	if (mi.is_header)
		mi.wdg.style.cursor = 'pointer';
}

function adhome_ch_mouseover(mi)
{
	if (document.page_loaded && mi.is_header) {
		mi.panel_ch_x = -1;
		mi.panel_ch_y = mi.wdg.offsetHeight;

		var obj = mi.wdg;
		mi.panel_ch_x += obj.offsetLeft;
		obj = obj.offsetParent;
		while (obj) {
			mi.panel_ch_x += obj.offsetLeft;
			mi.panel_ch_y += obj.offsetTop;
			obj = obj.offsetParent;
		}
		mi.panel_ch_min_w = mi.wdg.offsetWidth;

		if (typeof mi.td_class == 'undefined')
			mi.td_class = mi.wdg.className;

		if (mi.wdg.className == 'header_back cmenu_hd_norm_body')
			mi.wdg.className = 'header_back cmenu_hd_norm_body_hover';
		else if (mi.wdg.className == 'header_back cmenu_hd_sel_body')
			mi.wdg.className = 'header_back cmenu_hd_sel_body_hover';
	}
}

function adhome_menu_close(mi)
{
	if (document.page_loaded)
		mi.wdg.className = mi.td_class;
}

function adhome_ch_mouseout(mi)
{
	if (mi.is_header && mi.menuitems.length == 0)
		adhome_menu_close(mi);
}

function adhome_ch_panel_hide(mi)
{
	if (mi.is_header)
		adhome_menu_close(mi);
}

function page_init()
{
	document.page_loaded = true;

	if (document['cmenu_items']) {
		document['mc'] = new CMenu({
			iname: 'mc',

			side: 'down',
			orientation: 'right',

			animate: true,
			anim_step: 10,
			anim_interval: 40,

			transparency: true,
			transparency_ie6: false,

			min_opacity: 0,
			max_opacity: 100,

			ch_create: adhome_ch_create,
			ch_mouseover: adhome_ch_mouseover,
			ch_mouseout: adhome_ch_mouseout,
			ch_panel_hide: adhome_ch_panel_hide,

			panel_offset1_x: 0,
			panel_offset1_y: 0,
			panel_offset2_x: 1,
			panel_offset2_y: 0,

			itemborder_class: 'cmenu_itemborder',
			separator_class: 'cmenu_separator',
			panel_class: 'cmenu_panel',
			panel_tl_class: 'cmenu_tl',
			panel_tc_class: 'cmenu_tc',
			panel_tr_class: 'cmenu_tr',
			panel_ml_class: 'cmenu_ml',
			panel_mr_class: 'cmenu_mr',
			panel_bl_class: 'cmenu_bl',
			panel_bc_class: 'cmenu_bc',
			panel_br_class: 'cmenu_br',

			mi_empty_normal_class: 'cmenu_mi_empty_normal',
			mi_empty_hover_class: 'cmenu_mi_empty_hover',
			mi_full_normal_class: 'cmenu_mi_full_normal',
			mi_full_hover_class: 'cmenu_mi_full_hover'

		});
	
		var len = document['cmenu_items'].length;
		if (len > 0) {
			for (var i = 0; i < len; i++) {
				var item = document['cmenu_items'][i];
		
				if (typeof item.parent_id == 'undefined')
					this[item.id] = document['mc'].add_item(item);
				else
					this[item.id] = this[item.parent_id].add_item(item);
			}
		
			document['mc'].run();
		}
	}
}

addEvent(window, 'load', page_init);


var goto_top_type = -1;
var goto_top_itv = 0;

function goto_top_timer()
{
	var y = goto_top_type == 1 ? document.documentElement.scrollTop : document.body.scrollTop;
	var moveby = 15;

	y -= Math.ceil(y * moveby / 100);
	if (y < 0)
		y = 0;

	if (goto_top_type == 1)
		document.documentElement.scrollTop = y;
	else
		document.body.scrollTop = y;

	if (y == 0) {
		clearInterval(goto_top_itv);
		goto_top_itv = 0;
	}
}

function goto_top()
{
	if (goto_top_itv == 0) {
		if (document.documentElement && document.documentElement.scrollTop)
			goto_top_type = 1;
		else if (document.body && document.body.scrollTop)
			goto_top_type = 2;
		else
			goto_top_type = 0;

		if (goto_top_type > 0)
			goto_top_itv = setInterval('goto_top_timer()', 50);
	}
}
